"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _axios = _interopRequireDefault(require("axios"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ENDPOINT = 'https://www.sparkpool.com';
var TIMEOUT = 5000;

function request(_ref) {
  var endpoint = _ref.endpoint,
      timeout = _ref.timeout;

  var instance = _axios.default.create({
    baseURL: endpoint,
    timeout: timeout
  });

  instance.interceptors.response.use(function (response) {
    var _response$data;

    if (((_response$data = response.data) === null || _response$data === void 0 ? void 0 : _response$data.code) !== 200) {
      throw Error(response.data.message);
    }

    return response.data.data;
  }, function (error) {
    return Promise.reject(error);
  });
  return instance;
}

var _default = function _default(options) {
  var endpoint = options && options.endpoint || ENDPOINT;
  var timeout = options && options.timeout || TIMEOUT;
  var apiRequest = request(_objectSpread(_objectSpread({}, options), {}, {
    endpoint: endpoint,
    timeout: timeout
  }));
  return {
    currencyStats: function currencyStats(params) {
      return apiRequest.get('/v1/currency/stats', {
        params: params
      });
    },
    currencyStatsHistory: function currencyStatsHistory(params) {
      return apiRequest.get('/v1/currency/statsHistory', {
        params: params
      });
    },
    poolStats: function poolStats(params) {
      return apiRequest.get('/v1/pool/stats', {
        params: params
      });
    },
    minerSharesHistory: function minerSharesHistory(params) {
      return apiRequest.get('/v1/miner/sharesHistory', {
        params: params
      });
    },
    minerStats: function minerStats(params) {
      return apiRequest.get('/v1/miner/stats', {
        params: params
      });
    },
    workerCountHistory: function workerCountHistory(params) {
      return apiRequest.get('/v1/worker/countHistory', {
        params: params
      });
    },
    workerList: function workerList(params) {
      return apiRequest.get('/v1/worker/list', {
        params: params
      });
    },
    workerSharesHistory: function workerSharesHistory(params) {
      return apiRequest.get('/v1/worker/sharesHistory', {
        params: params
      });
    },
    workerStats: function workerStats(params) {
      return apiRequest.get('/v1/worker/stats', {
        params: params
      });
    },
    billList: function billList(params) {
      return apiRequest.get('/v1/bill/list', {
        params: params
      });
    },
    billStats: function billStats(params) {
      return apiRequest.get('/v1/bill/stats', {
        params: params
      });
    },
    payoutHistory: function payoutHistory(params) {
      return apiRequest.get('/v1/bill/payoutHistory', {
        params: params
      });
    }
  };
};

exports.default = _default;